package ca.mcgill.sable.abc.impact.visualizer.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.resource.ImageDescriptor;

import ca.mcgill.sable.abc.impact.visualizer.model.ImageFactory;
import ca.mcgill.sable.abc.impact.visualizer.views.ImpactView;

/**
 * This action toggles whether the impact view follows the
 * active editor's selection.
 */
public final class ToggleLinkingAction extends Action {
	
	private ImpactView impactView;
	
	public ToggleLinkingAction(ImpactView impactView) {
		super("Link editor");
		setDescription("Link with editor");
		setToolTipText("Link with editor");
		setImageDescriptor(ImageDescriptor.createFromImage(ImageFactory.LINKEDITOR.getImage()));
		setChecked(impactView.isLinkingEnabled());
		this.impactView = impactView;
	}

	public void run() {
		impactView.setLinkingEnabled(isChecked());
	}

}
