package ca.mcgill.sable.abc.impact.visualizer.console;

import org.eclipse.ui.console.ConsolePlugin;
import org.eclipse.ui.console.IConsole;
import org.eclipse.ui.console.IConsoleFactory;
import org.eclipse.ui.console.IConsoleManager;
import org.eclipse.ui.console.MessageConsole;

import ca.mcgill.sable.abc.impact.visualizer.util.ImpactConstants;

public final class ImpactConsoleFactory implements IConsoleFactory {

	private static MessageConsole console = new MessageConsole(
			ImpactConstants.IMPACT_CONSOLE_NAME, null);

	public void openConsole() {
		showConsole();
	}

	public static void showConsole() {
		if (console != null) {
			IConsoleManager manager = ConsolePlugin.getDefault()
					.getConsoleManager();
			IConsole[] existing = manager.getConsoles();
			boolean exists = false;
			for (int i = 0; i < existing.length; i++) {
				if (console == existing[i])
					exists = true;
			}
			if (!exists) {
				manager.addConsoles(new IConsole[] { console });
			}
			manager.showConsoleView(console);
		}
	}

	public static MessageConsole getConsole() {
		return console;
	}
}
