package ca.mcgill.sable.abc.impact.visualizer.model;

import java.util.List;

import org.eclipse.core.runtime.Platform;

import abc.impact.utils.ImpactUtil;
import abc.weaving.aspectinfo.AdviceDecl;
import abc.weaving.aspectinfo.AdviceSpec;
import abc.weaving.aspectinfo.AfterAdvice;
import abc.weaving.aspectinfo.AroundAdvice;
import abc.weaving.aspectinfo.BeforeAdvice;
import abc.weaving.aspectinfo.Formal;
import ca.mcgill.sable.abc.impact.visualizer.util.ImpactPluginUtil;

public final class AdviceDeclTreeNode extends AbstractTreeNode 
	implements IActPosition {
	
	private final AdviceDecl adviceDecl;

	public AdviceDeclTreeNode(ITreeNode parent, final AdviceDecl adviceDecl) {
		super(parent);
		this.adviceDecl = adviceDecl;
		StringBuffer nameb = new StringBuffer();
		nameb.append(adviceDecl.getAdviceSpec().toString());
		nameb.append('(');
		List<Formal> formals = adviceDecl.getFormals();
		boolean emptyFormalStr = true;
		for (Formal formal : formals) {
			if (! ImpactUtil.isThisJoinPointFormal(formal)) {
				nameb.append(formal);
				nameb.append(", ");
				emptyFormalStr = false;
			}
		}
		if (! emptyFormalStr) nameb.setLength(nameb.length() - 2);
		nameb.append(')');
		name = nameb.toString();
		
		AdviceSpec adSpec = adviceDecl.getAdviceSpec();
		if (adSpec instanceof AroundAdvice) {
			image = ImageFactory.AROUND_ADVICE.getImage();
		}
		if (adSpec instanceof BeforeAdvice) {
			image = ImageFactory.BEFORE_ADVICE.getImage();
		}
		if (adSpec instanceof AfterAdvice) {
			image = ImageFactory.AFTER_ADVICE.getImage();
		}
	}
	
	public AdviceDecl getAdviceDecl() {
		return adviceDecl;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}

	public RevealData getRevealData() {
		return new RevealData(ImpactPluginUtil.getFileFrom(adviceDecl.getAspect()),
				adviceDecl.getPosition());
	}
}
