package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.swt.graphics.Image;

import ca.mcgill.sable.abc.impact.visualizer.ImpactPlugin;

public enum ImageFactory {
	ASPECT,
	
	BEFORE_ADVICE,
	AFTER_ADVICE,
	AROUND_ADVICE,
	
	ITDFIELD_PRI,
	ITDFIELD_DEF,
	ITDFIELD_PUB,
	
	ITDMETHOD_PRI,
	ITDMETHOD_DEF,
	ITDMETHOD_PUB,
	
	ITDCONSTRUCTOR_PRI,
	ITDCONSTRUCTOR_DEF,
	ITDCONSTRUCTOR_PUB,
	
	DEC_PARENTS,
	
	IMPACT_STATE,
	IMPACT_COMPUTATION,
	IMPACT_SHADOWING,
	IMPACT_LOOKUP,
	
	COMPUTATION_ADDITION,
	COMPUTATION_ELIMINATION,
	COMPUTATION_DEFINITE_SUBSTITUTION,
	COMPUTATION_CONDITIONAL_SUBSTITUTION,
	COMPUTATION_MIXED,
	
	STATE_DIRECT,
	STATE_INDIRECT,
	STATE_FIELD,
	
	SHADOWING_FIELD,
	
	LOOKUP_METHOD,
	
	PLACE_OTHER,
	PLACE_PROTECTED,
	PLACE_PACKAGE,
	PLACE_CLASS,
	
	CODE,
	CODE_ASPECT,
	
	EXPANDALL,
	COLLAPSEALL,
	LINKEDITOR
	;
	

	private Image image;

	private ImageFactory() {
		this.image = ImpactPlugin.getImageDescriptor("icons/" + this.name().toLowerCase() + ".gif")
				.createImage();
	}

	public Image getImage() {
		return image;
	}
}
