package ca.mcgill.sable.abc.impact.visualizer.model;

import org.eclipse.core.runtime.Platform;

import abc.impact.impact.ReferredPlace;

public final class ReferredPlaceTreeNode extends AbstractTreeNode implements
		IActCollapse {

	final private ReferredPlace referredPlace;

	public ReferredPlaceTreeNode(ITreeNode parent, final ReferredPlace referredPlace) {
		super(parent);
		this.referredPlace = referredPlace;
		this.name = referredPlace.toString();
		
		if (referredPlace == ReferredPlace.OTHER) {
			this.image = ImageFactory.PLACE_OTHER.getImage();
		} else if (referredPlace == ReferredPlace.PROTECTED) {
			this.image = ImageFactory.PLACE_PROTECTED.getImage();
		} else if (referredPlace == ReferredPlace.PACKAGE) {
			this.image = ImageFactory.PLACE_PACKAGE.getImage();
		} else if (referredPlace == ReferredPlace.CLASS) {
			this.image = ImageFactory.PLACE_CLASS.getImage();
		}
	}

	public ReferredPlace getReferredPlace() {
		return referredPlace;
	}

	public Object getAdapter(Class adapter) {
		return Platform.getAdapterManager().getAdapter(this, adapter);
	}
}
